var search_data = {"index":{"searchIndex":["eldritch","dsl","group","interruptederror","nilgroup","task","thread","<<()","<<()","abort()","abort()","async()","async_block()","async_method()","async_method_name()","eldritch_group()","in_eldritch_group?()","inject_dsl()","interrupt()","interrupt()","join()","join_all()","new()","new()","nil?()","others()","start()","sync()","synchronize()","together()","unset_thread_task()","value()"],"longSearchIndex":["eldritch","eldritch::dsl","eldritch::group","eldritch::interruptederror","eldritch::nilgroup","eldritch::task","thread","eldritch::group#<<()","eldritch::nilgroup#<<()","eldritch::group#abort()","eldritch::task#abort()","eldritch::dsl#async()","eldritch::dsl#async_block()","eldritch::dsl#async_method()","eldritch::dsl#async_method_name()","thread#eldritch_group()","thread#in_eldritch_group?()","eldritch::inject_dsl()","eldritch::group#interrupt()","eldritch::task#interrupt()","eldritch::task#join()","eldritch::group#join_all()","eldritch::group::new()","eldritch::task::new()","eldritch::nilgroup#nil?()","eldritch::group#others()","eldritch::task#start()","eldritch::dsl#sync()","eldritch::group#synchronize()","eldritch::dsl#together()","eldritch::task#unset_thread_task()","eldritch::task#value()"],"info":[["Eldritch","","Eldritch.html","",""],["Eldritch::DSL","","Eldritch/DSL.html","","<p>Provides DSL for:\n<p>{#async async methods}\n<p>{#async async blocks}\n"],["Eldritch::Group","","Eldritch/Group.html","","<p>Represents a group of {Task tasks} or {DSL#async async calls/block}. It is used to act upon all the tasks …\n"],["Eldritch::InterruptedError","","Eldritch/InterruptedError.html","",""],["Eldritch::NilGroup","","Eldritch/NilGroup.html","",""],["Eldritch::Task","","Eldritch/Task.html","","<p>Runs a block in parallel and allows for interaction with said block\n"],["Thread","","Thread.html","",""],["<<","Eldritch::Group","Eldritch/Group.html#method-i-3C-3C","(task)",""],["<<","Eldritch::NilGroup","Eldritch/NilGroup.html#method-i-3C-3C","(task)",""],["abort","Eldritch::Group","Eldritch/Group.html#method-i-abort","()","<p>Aborts the other async calls/blocks in the group\n<p><strong>Warning</strong>: This call will directly kill underlying threads. …\n"],["abort","Eldritch::Task","Eldritch/Task.html#method-i-abort","()","<p>Forces the task to end\n<p>This kills the underlying thread. This is a dangerous call.\n"],["async","Eldritch::DSL","Eldritch/DSL.html#method-i-async","(method=nil, &block)","<p>Creates an asynchronous method or starts an async block\n<p>If a block is passed, this will be an async block. …\n"],["async_block","Eldritch::DSL","Eldritch/DSL.html#method-i-async_block","(&block)",""],["async_method","Eldritch::DSL","Eldritch/DSL.html#method-i-async_method","(method)",""],["async_method_name","Eldritch::DSL","Eldritch/DSL.html#method-i-async_method_name","(method)",""],["eldritch_group","Thread","Thread.html#method-i-eldritch_group","()",""],["in_eldritch_group?","Thread","Thread.html#method-i-in_eldritch_group-3F","()",""],["inject_dsl","Eldritch","Eldritch.html#method-c-inject_dsl","()","<p>Injects the DSL in the main\n<p>This is automatically called when you call\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">require</span> <span class=\"ruby-string\">&#39;eldritch&#39;</span>\n</pre>\n"],["interrupt","Eldritch::Group","Eldritch/Group.html#method-i-interrupt","()","<p>Interrupts the other async calls/blocks in the group\n<p>Interruptions are done using exceptions that can …\n"],["interrupt","Eldritch::Task","Eldritch/Task.html#method-i-interrupt","()","<p>Interrupts the task\n<p>This is done by raising an {InterruptedError} in the task block. This can be caught …\n"],["join","Eldritch::Task","Eldritch/Task.html#method-i-join","()","<p>Waits for the task to complete\n"],["join_all","Eldritch::Group","Eldritch/Group.html#method-i-join_all","()",""],["new","Eldritch::Group","Eldritch/Group.html#method-c-new","()",""],["new","Eldritch::Task","Eldritch/Task.html#method-c-new","(&block)","<p>Creates a new Task instance\n<p><em>Note</em>: this method does not yield the block directly this is done by {#start} …\n"],["nil?","Eldritch::NilGroup","Eldritch/NilGroup.html#method-i-nil-3F","()",""],["others","Eldritch::Group","Eldritch/Group.html#method-i-others","()","<p>@return [Array&lt;Task&gt;] the other async calls/blocks in the group\n"],["start","Eldritch::Task","Eldritch/Task.html#method-i-start","()","<p>Starts the task\n<p>This will yield the task to the block passed in the constructor.\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">task</span> = <span class=\"ruby-constant\">Eldritch</span><span class=\"ruby-operator\">::</span><span class=\"ruby-constant\">Task</span>.<span class=\"ruby-identifier\">new</span> <span class=\"ruby-operator\">...</span>\n</pre>\n"],["sync","Eldritch::DSL","Eldritch/DSL.html#method-i-sync","(task)","<p>Allows async methods to be called like synchronous methods\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">sync</span> <span class=\"ruby-identifier\">send_email</span>(<span class=\"ruby-value\">42</span>) <span class=\"ruby-comment\"># send_mail is async</span>\n</pre>\n<p>@param …\n"],["synchronize","Eldritch::Group","Eldritch/Group.html#method-i-synchronize","(&block)","<p>Yields the block in mutual exclusion with all the async calls/tasks\n<p>@yield\n"],["together","Eldritch::DSL","Eldritch/DSL.html#method-i-together","()","<p>Creates a group of async call and blocks\n<p>When async blocks and calls are inside a together block, they …\n"],["unset_thread_task","Eldritch::Task","Eldritch/Task.html#method-i-unset_thread_task","()",""],["value","Eldritch::Task","Eldritch/Task.html#method-i-value","()","<p>The return value of the task\n<p>If the task is still running, it will block until it is done and then fetch …\n"]]}}